/*
    Copyright (C) 2025 Daniel Kos

    This file is part of Hipe.

    Hipe is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Hipe is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hipe.  If not, see <http://www.gnu.org/licenses/>.
*/


//Alternative mouse cursor rendering for hardware where a mouse cursor is not adequately provided.

#pragma once

#include <QPainter> //for cursor
#include <QWidget>


class Container;


class MouseCursor : public QWidget {
    Q_OBJECT
public:
    MouseCursor(Container* c, QWidget* parent = nullptr);
    ~MouseCursor();
protected:
    bool eventFilter(QObject* obj, QEvent* event) override;
    void paintEvent(QPaintEvent*) override;
    void timerEvent(QTimerEvent*) override;
private:
    QPixmap m_cursorPixmap;
    Container* c;
    bool mousePressed = false;
};
